GET Staged Transaction

GET /payout/v1/stagedtransactions

Development Guide:

The 'Retrieve Staged Transaction' endpoint will look up a transaction by referenceNumber and will provide additional information about a Payout. In some jurisdictions, regulation stipulates "additional transactional information" is to be provided at the time of Payout. This endpoint securely provides the additional information for regulatory purposes.



1. Prepare headers, authentication & parameters:

The application must call the 'Retrieve a transaction' endpoint with a GET HTTP method, providing the OAuth access_token and all other required headers. The application must pass the transaction referenceNumber as a path parameter to retrieve the transaction.


Note: MoneyGram uses the OAuth 2.0 framework. The application must use their OAuth client credentials to generate an access_token by calling the Get Access Token endpoint. The token is valid for 1 hour and must be passed as a header value in all subsequent API HTTP calls. Learn More


🚀

Launch Example Code




2. Make a request and handle the response:

The application must call 'Retrieve Staged transaction' endpoint with a GET HTTP method. The application must build to handle the following response scenarios:


  • Success | Parse the Response | 200 OK HTTP Status | "availableForPayout": true When the 'Retrieve a transaction' by referenceNumber endpoint responds with a 200 HTTP Status the response will typically return the transactionId, payoutId, sender, receiver and transactionInformation fields. There will be additional data about the sender provided, depending on market regulation.

  • Failed | Handle the Error | 400 Bad Request HTTP Status When the 'Retrieve a Transaction' endpoint responds with 400 HTTP Status, specific error code/s will be returned with an array of offending fields. The application will need to resolve these errors and resubmit the request.

Note: Access to the API is secured by business rules and will only be returned to eligible partners. To understand how you access this API, please refer to your MoneyGram technical consultant.


🚀

Launch Example Code

.




4. You're Done! Proceed to Update a Transaction API:

The application must execute the 'Update a staged transaction' endpoint to get the readyForCommit": true.





Business Rules to Code


🔎
  • Ready for Payout & Available status: The transaction can only be paid out if the transaction is in an AVAILABLE status and the "availableForPayout": true is returned in the response.
    • Send & Payout at the same store: A Payout cannot be received at the same store location where the transaction was sent (i.e. The application cannot Payout a transaction using the same partnerAgentId that was used to send the transfer).


Code Examples


const axios = require('axios');
const { v4: uuidv4 } = require('uuid');

const additionalInformation = async () => {

    // Step 1: Read configuration values with upmost security
    const token = "your_access_token_from_oauth_response"
    // For production - api.moneygram.com & For test - sandboxapi.moneygram.com
    const transactionId = "current_transaction_id";
    const host = "sandboxapi.moneygram.com";
    const url = 'https://' + host + '/payout/v1/stagedtransactions/' + referenceNumber + '/additionalInformation';

    // Step 2: Create the GET request headers & params

    const headers = {
        'Content-Type': 'application/json',
        'X-MG-ClientRequestId': uuidv4(), // New UUID for each request tracing
        'Authorization': 'Bearer ' + token,
    };

    const params = {
        agentPartnerId: "your_partner_id",
        targetAudience: "AGENT_FACING",
        userLanguage: "en-US",
    }

    try {
        // Step 3: Send the request and obtain the response
        axios.get(url, { params, headers })
            .then(function (response) {
                // Step 4: Parse the success response and process further
                // Verify readyForCommit is true, if yes, transaction is ready to commit
                console.log(JSON.stringify(response.data, null, 2))
            })
            .catch(function (error) {
                // Step 5: Parse the error response and handle the errors
                if (error.response) {
                    console.log('Response status:', error.response.status);
                    console.log('Response body:', error.response.data);
                } else {
                    // TODO: handle generic errors
                    console.error('Error:', error.message);
                }
            });
    } catch (error) {
        // TODO: handle exception
        console.error('Error:', error.message);
    }
};

additionalInformation();
import requests
import uuid
import json

def additional_information():
    # Step 1: Read configuration values with upmost security
    token = "your_access_token_from_oauth_response"
    # For production - api.moneygram.com & For test - sandboxapi.moneygram.com
    transactionId = "current_transaction_id";
    host = "sandboxapi.moneygram.com";
    url = 'https://' + host + '/payout/v1/stagedtransactions/'+ referenceNumber + '/additionalInformation';

    # Step 2: Create the GET request headers & params

    headers = {
        'Content-Type': 'application/json',
        'X-MG-ClientRequestId': str(uuid.uuid4()), # New UUID for each request tracing
        'Authorization': 'Bearer ' + token,
    }

    params = {
        'agentPartnerId': 'your_partner_id',
        'targetAudience': 'AGENT_FACING',
        'userLanguage': 'en-US',
    }

    try:
        # Step 3: Send the request and obtain the response
        response = requests.get(url, params=params, headers=headers)

        # Step 4: Parse the success response and process further
        if response.status_code == 200:
            parsed_response = json.dumps(json.loads(response.text), indent=2)
            print(parsed_response)
        else:
            # Step 5: Parse the error response and handle the errors
            print("Request failed with status code:", response.status_code)
            print(json.dumps(json.loads(response.text), indent=2))

    except requests.exceptions.RequestException as e:
        # Print any error that occurred during the request
        # TODO: handle exception
        print("An error occurred:", e)

additional_information()
package payout;

import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.util.UUID;

public class AdditionalInformation {

    public static void main(String[] args) {
        // Step 1: Read configuration values with upmost security
        String token = "your_access_token_from_oauth_response";

        // For production - api.moneygram.com & For test - sandboxapi.moneygram.com
        String host = "sandboxapi.moneygram.com";

        // Step 2: Create the GET request headers & params
        // Mandatory Query params
        String agentPartnerId = "your_partner_id";
        String userLanguage = "en-US";

        // Optional Query params
        String targetAudience = "AGENT_FACING";

        // Mandatory Path params
        String transactionId = "current_transaction_id";

        String uri = "https://" + host + "/payout/v1/stagedtransactions/" + referenceNumber + "/additionalInformation"
                + "agentPartnerId=" + agentPartnerId
                + "&userLanguage=" + userLanguage
                + (targetAudience.isBlank() ? "" : "&targetAudience=" + targetAudience);

        HttpClient httpClient = HttpClient.newHttpClient();
        HttpRequest request = HttpRequest.newBuilder()
                .uri(URI.create(uri))
                .GET()
                .setHeader("Authorization", "Bearer " + token)
                .setHeader("X-MG-ClientRequestId", String.valueOf(UUID.randomUUID()))
                .build();

        try {
            // Step 3: Send the request and obtain the response
            HttpResponse<String> response = httpClient.send(request, HttpResponse.BodyHandlers.ofString());

            // Retrieve the status code and body from the response
            int statusCode = response.statusCode();

            // Step 4: Parse the success response and process further
            if (statusCode == 200) {
                String responseBody = response.body();
                System.out.println(responseBody);
            } else {
                // Step 5: Parse the error response and handle the errors
                String responseBody = response.body();
                System.out.println(responseBody);
            }
        } catch (Exception e) {
            e.printStackTrace();
            // TODO: handle exception
        }

    }
}




API structure


Header parameters

FieldTypeRequired/ OptionalDescription
X-MG-ClientRequestIdStringRequiredClient request ID that can be passed by the client application. Client request ID must be unique within a single session for unique requests. This attribute can be used for ensuring idempotent request processing for some APIs. MoneyGram recommends using a UUID for the value of this field.
X-MG-ConsumerIPAddressStringOptionalIP address of the system initiating the session.



Query parameters

FieldTypeRequired/ OptionalDescription
targetAudienceStringRequiredTailors MoneyGram’s error messages and field metadata to an in-store, digital, or crypto customer. (Enumerated value)
Note: For a full list of accepted target audience values, see the TARGET_AUDIENCE enumeration from the Reference Data Enumerations endpoint.
userLanguageStringRequiredLanguage used by the user/operator.
agentPartnerIdStringRequiredUnique agent or partner identifier.
posIdStringOptionalPoint of sale identifier of the client performing the API call.
operatorIdString Max length: 80RequiredOperator name or ID of the user performing the transaction. The name or ID must be populated from the agent or partner system and cannot be edited by the user.



Path parameters

FieldTypeRequired/ OptionalDescription
referenceNumberStringRequiredMoneyGram's reference number for the transaction



Response fields

FieldTypeRequired/ OptionalDescription
transactionIdString
Max length: 36
OptionalUnique identifier for the transaction resource
payoutIdStringOptionalUnique identifier for the transaction session
availableForPayoutBooleanOptionalIdentifies if the transaction is in a status available for payout
transactionStatusStringOptionalMoneyGram's transaction status
transactionSubStatus.substatusStringOptionalMoneyGram's transaction sub-status
transactionSubStatus.targetCustomerStringOptionalCustomer associated with a sub-status code
transactionSubStatus.customerActionStringOptionalMessage associated with the sub-status code
transactionSubStatus.dataToCollect.codeStringOptionalUnique code to identify the data or document to collect.
transactionSubStatus.dataCollect.dataCollectionStringOptionalData or document needed to be collected from customer.
originatingCountryCodeString
Max Length: 3
Optional3 digit ISO destination country code
destinationCountryCodeString
Max Length: 3
OptionalTransaction destination country (ISO alpha-3 code)
Note: For a full list of accepted destinationCountryCode ISO codes see Reference data API module and the subdivision endpoint: https://moneygram-group.readme.io/moneygram-developer/docs/countries-iso3-code
serviceOptionCodeString
Max length: 21
RequiredUnique category code to identify the transaction method
For a full list of accepted serviceOptionCodes per destinationCountry see Reference data API module and the service options endpoint: https://moneygram-group.readme.io/moneygram-developer/docs/payout-options
serviceOptionNameString
Max length: 50
OptionalUnique name to identify the transaction method
Note: For a full list of accepted serviceOptionName per destinationCountry see Reference data API module and the service options endpoint: https://moneygram-group.readme.io/moneygram-developer/docs/service-options
sendAmount.amount.valueNumber
Min length: 0
Max length: 14
Max Decimal Value: 3
RequiredTransaction amount and currency excluding fees and exchange rate. Transaction currency (ISO alpha-3 code): https://moneygram-group.readme.io/moneygram-developer/docs/currencies
Note: For Crypto partners this is the fiat currency for the buy/sell or ramp on/ramp off
sendAmount.amount.currencyCodeStringRequiredThe sendAmount.amount.value currency code (ISO alpha-3 code)
sendAmount.fees.valueNumber
Min length: 0
Max length: 14
Max Decimal Value: 3
RequiredFee amount and fee currency applied to transaction (Fee currency uses ISO alpha-3 code)
sendAmount.fees.currencyCodeStringRequiredThe sendAmount.fees.value currency code (ISO alpha-3 code)
sendAmount.taxes.valueNumber
Min length: 0
Max length: 14
Max Decimal Value: 3
OptionalTax amount and tax currency applied to the transaction by the the origin country (Tax currency uses ISO alpha-3 code)
sendAmount.taxes.currencyCodeStringOptionalThe sendAmount.taxes.value currency code (ISO alpha-3 code)
sendAmount.discountsApplied.totalDiscountNumber
Min length: 0
Max length: 14
Max Decimal Value: 3
OptionalTransaction discount amount applied and currency type excluding fees and exchange rate. Transaction currency (ISO alpha-3 code)
sendAmount.discountsApplied.promotionDetailsString
Max length: 50
OptionalAdditional details about the applied promotion to the transaction
sendAmount.total.valueNumber
Min length: 0
Max length: 14
Max Decimal Value: 3
RequiredTransaction total amount and transaction total currency including fees, taxes and discount. (Transaction total amount uses ISO alpha-3 code)
sendAmount.total.currencyCodeStringRequiredThe sendAmount.total.value currency code (ISO alpha-3 code)
receiveAmount.amount.valueNumber
Min length: 0
Max length: 14
Max Decimal Value: 3
RequiredTransaction received amount and transaction receive currency (Transaction total amount uses ISO alpha-3 code)
receiveAmount.amount.currencyCodeStringRequiredThe receiveAmount.amount.value currency code (ISO alpha-3 code)
receiveAmount.fees.valueNumber
Min length: 0
Max length: 14
Max Decimal Value: 3
OptionalReceived fee and receive currency applied to the transaction by the destination country (Transaction total amount uses ISO alpha-3 code)
receiveAmount.fees.currencyCodeStringOptionalThe receiveAmount.fees.value currency code (ISO alpha-3 code)
receiveAmount.taxes.valueNumber
Min length: 0
Max length: 14
Max Decimal Value: 3
OptionalTax amount and tax currency applied to the transaction by the the origin country (Tax currency uses ISO alpha-3 code)
receiveAmount.taxes.currencyCodeStringOptionalThe receiveAmount.taxes.value currency code (ISO alpha-3 code)
receiveAmount.total.valueNumber
Min length: 0
Max length: 14
Max Decimal Value: 3
RequiredReceive amount total and receive transaction currency to be picked up/deposited in destination country including fees, taxes and discount. (Transaction total amount uses ISO alpha-3 code)
receiveAmount.total.currencyCodeStringRequiredThe receiveAmount.total.value currency code (ISO alpha-3 code)
receiveAmount.fxRateNumber
Max Decimal Value: 6
RequiredFX rate applied to transaction
receiveAmount.fxRateEstimatedBooleanOptionalIndicates whether the FX is “estimated” and amount, taxes and total cannot be guaranteed. The word “estimated” must appear before receiveAmount.amount, receiveAmount.taxes and receiveAmount.total only when true.
originalReceiveAmount.amount.valueNumberRequiredThe transaction's send or receive amount, fee, taxes, total discount applied, transaction total, or reconcile amounts. See the APIs documentation for detailed information for the field
originalReceiveAmount.amount.currencyCodeStringRequiredValue's Currency code (ISO alpha-3 code
originalReceiveAmount.fees.valueNumberOptionalThe transaction's send or receive amount, fee, taxes, total discount applied, transaction total, or reconcile amounts. See the APIs documentation for detailed information for the field
originalReceiveAmount.fees.currencyCodeStringOptionalValue's Currency code (ISO alpha-3 code
originalReceiveAmount.taxes.valueNumberOptionalThe transaction's send or receive amount, fee, taxes, total discount applied, transaction total, or reconcile amounts. See the APIs documentation for detailed information for the field
originalReceiveAmount.taxes.currencyCodeStringOptionalValue's Currency code (ISO alpha-3 code
originalReceiveAmount.total.valueNumberRequiredThe transaction's send or receive amount, fee, taxes, total discount applied, transaction total, or reconcile amounts. See the APIs documentation for detailed information for the field
originalReceiveAmount.total.currencyCodeStringRequiredValue's Currency code (ISO alpha-3 code
originalReceiveAmount.fxRateNumber
Max Decimal Value: 6
RequiredFx Rate applied to transaction
originalReceiveAmount.fxRateEstimatedBooleanOptionalIndicates whether the FX is “estimated” and amount, taxes and total cannot be guaranteed. The word “estimated” must appear before receiveAmount.amount, receiveAmount.taxes and receiveAmount.total only when true.
estimatedReceiveAmountInLocalCurrency.total.valueNumberRequiredTransaction received amount and transaction receive currency (Transaction total amount uses ISO alpha-3 code)
estimatedReceiveAmountInLocalCurrency.total.currencyCodeStringRequiredThe estimatedReceiveAmountInLocalCurrency.amount.value currency code (ISO alpha-3 code)
estimatedReceiveAmountInLocalCurrency.fxRateNumberRequiredFX Rate Charged
estimatedReceiveAmountInLocalCurrency.fxRateEstimatedBooleanOptionalIndicates whether the all attributes related to Fx are estimated
sender.name.firstNameString
Min length: 1
Max length: 20
RequiredFirst name
sender.name.middleNameString
Min length: 1
Max length: 20
OptionalMiddle name (if applicable)
sender.name.lastNameString
Min length: 1
Max length: 30
RequiredLast name
sender.name.secondLastNameString
Min length: 1
Max length: 30
OptionalSecond last name
receiver.name.firstNameString
Min length: 1
Max length: 20
RequiredFirst name
receiver.name.middleNameString
Min length: 1
Max length: 20
OptionalMiddle Name
receiver.name.lastNameString
Min length: 1
Max length: 30
RequiredLast name
receiver.name.secondLastNameString
Min length: 1
Max length: 30
OptionalSecond last name
receiver.address.line1String Min length: 5 Max length: 30RequiredResidence address line 1
receiver.address.line2String Min length: 0 Max length: 80OptionalResidence address line 2
(if applicable)
receiver.address.line3String Min length: 0 Max length: 80OptionalResidence address line 3
(if applicable)
receiver.address.cityString Min length: 1 Max length: 20RequiredCity of Residence
receiver.address.countrySubdivisionCodeString Length: 6OptionalState/province of residence
receiver.address.countryCodeString Length: 3RequiredCountry of residence
(ISO Alpha-3 Code)
receiver.address.postalCodeString Min length: 2 Max length: 10OptionalPostal code/ZIP code of residence
receiver.mobilePhone.numberString Min length: 5 Max length: 14OptionalPhoen Number
receiver.mobilePhone.countryDialCodeString Min length: 1 Max length: 3OptionalCountry calling code
(ISO alpha-3 code)
receiver.emailString Min length: 1 Max length: 255OptionalEmail address
receiver.personalDetails.genderCodeStringOptionalGender (Enumerated value)
receiver.personalDetails.dateOfBirthString Length: 10RequiredDate of birth (YYYY-MM-DD)
receiver.personalDetails.birthCityString Min length: 0 Max length: 20OptionalCity of birth
receiver.personalDetails.birthCountryCodeString Max Length: 3RequiredCountry of birth (ISO alpha-3 code) NOTE: For a full list of accepted birth.CountryCodes see ‘Reference data API module’ and the countryInfo endpoint:
receiver.personalDetails.citizenshipCountryCodeString Max Length: 3OptionalCitizenship Code (ISO alpha-3 code)
receiver.personalDetails.occupationCodeStringOptionalOccupation/Employment (Enumerated value) NOTE: For a full list of accepted Occupation Codes. See the OCCUPATION enumeration from the Reference Data Enumerations endpoint
receiver.personalDetails.politicalExposedPersonBoolenOptionalFlag to declare a Politically Exposed Person (PEP)
receiver.personalDetails.nationalityCountryCodeString Min Length: 3 Max Length: 3OptionalCountry of citizenship (ISO alpha-3 code)
receiver.primaryIdentification.typeCodeStringOptionalexample: SSN for Social Security Number identification document.
Type of identification document (Enumerated Value)
receiver.primaryIdentification.idString Max length: 30RequiredIdentification document number
receiver.primaryIdentification.issueCountrySubdivisionCodeString Max length: 6OptionalIssuing state/province of identification document
receiver.primaryIdentification.issueCountryCodeString Max Length: 3RequiredIssuing country of identification document
receiver.primaryIdentification.expirationYearString Length: 4 Format: YYYYOptionalExpiration year of identification document (YYYY)
receiver.primaryIdentification.expirationMonthString Length: 4 Format: MMOptionalExpiration month of identification document (MM)
receiver.primaryIdentification.expirationDayString Length: 4 Format: DDOptionalExpiration month of identification document (DD)
receiver.primaryIdentification.issueAuthorityString Min length: 0 Max length: 30OptionalIssuing authority of identification document
receiver.primaryIdentification.issueCityString Min length: 0 Max length: 20OptionalIssuing city of identification document
receiver.primaryIdentification.issueYearString Length: 4 Format: YYYYOptionalExpiration year of identification document (YYYY)
receiver.primaryIdentification.issueMonthString Length: 4 Format: MMOptionalExpiration month of identification document (MM)
receiver.primaryIdentification.issueDayString Length: 4 Format: DDOptionalExpiration month of identification document (DD)
receiver.secondaryIdentification.typeCodeStringOptionalexample: SSN for Social Security Number identification document
Type of identification document (Enumerated Value)
receiver.secondaryIdentification.idString Max length: 30OptionalIdentification document number
receiver.secondaryIdentification.issueCountrySubdivisionCodeString Max length: 6OptionalIssuing state/province of identification document
receiver.secondaryIdentification.issueCountryCodeString Max length: 3OptionalIssuing country of identification document
receiver.secondaryIdentification.expirationYearString Length: 4 Format: YYYYOptionalExpiration year of identification document (YYYY)
receiver.secondaryIdentification.expirationMonthString Length: 4 Format: MMOptionalExpiration month of identification document (MM)
receiver.secondaryIdentification.expirationDayString Length: 4 Format: DDOptionalExpiration month of identification document (DD)
receiver.secondaryIdentification.issueAuthorityString Min length: 0 Max length: 30OptionalIssuing authority of identification document
receiver.secondaryIdentification.issueCityString Min length: 0 Max length: 20OptionalIssuing city of identification document
receiver.secondaryIdentification.issueYearString Length: 4 Format: YYYYOptionalExpiration year of identification document (YYYY)
receiver.secondaryIdentification.issueMonthString Length: 4 Format: MMOptionalExpiration month of identification document (MM)
receiver.secondaryIdentification.issueDayString Length: 4 Format: DDOptionalExpiration month of identification document (DD)
additionalDetailsDynamicOptionalDynamic field key/values


Did this page help you?